`timescale 1ns / 100ps

module top(
	output reg reset,
	output [7:0] cpu_addr,
//	output [7:0] cpu_addrB,
	output wire LEDout,
	output [7:0] cpu_dataout
//	output [7:0] cpu_dataoutB
	);

	GSR GSR_INST (.GSR (~reset));
	PUR PUR_INST (.PUR (~reset));
	
//	wire [7:0] cpu_addr;
	reg [7:0] cpu_datain1;
	reg [7:0] cpu_datain2;
//	wire [7:0] cpu_dataout;
	wire [7:0] mem_dataout;
	reg [7:0] mem_dataout1;
	wire [7:0] rwdatain;
	wire [8:0] cpu_addr2;
	wire cpu_we;

//	wire [7:0] cpu_addrB;
	reg [7:0] cpu_datain1B;
	reg [7:0] cpu_datain2B;
//	wire [7:0] cpu_dataoutB;
	wire [7:0] mem_dataoutB;
	reg [7:0] mem_dataout1B;
	wire [7:0] rwdatainB;
	wire [7:0] cpu_addr2B;
	wire cpu_weB;

	wire fpga_clk;
	wire pll_clk;
	wire mem_clk;
	reg q1_clk;
	reg q2_clk;
	wire cpu_clk;
//	reg reset;
	reg [7:0] counting;
	reg count_reset;
	reg count_check;
//	reg [26:0] LEDcount;
//	reg LEDswitch;
	/* Declare a array 256 bytes */ 

	
	OSCH #(.NOM_FREQ("133.0")) rc_oscillator(.STDBY(1'b0), .OSC(fpga_clk));
	// NOM_FREQ: 2.08 (default), 2.15, 2.22, 2.29, 2.38, 2.46, 2.56, 2.66, 2.77, 2.89, 3.02, 3.17,
	// , 19.0, 20.46, 22.17, 24.18, 26.6, 29.56, 33.25, 38.0, 44.33, 53.2, 66.5, 88.67, 133.0 (in MHz)

	MiniClock MC(.CLKI(fpga_clk), .CLKOP(mem_clk), .CLKOS(cpu_clk));

	initial
	begin
		reset=1'b1;
		counting=8'b0;
//		q1_clk=1'b0;
//		q2_clk=1'b0;
//		mem_clk=1'b0;
//		cpu_clk=1'b0;
//		LEDswitch=1'b0;
//		LEDcount=27'h00000000;


	end
/*
	always @(posedge pll_clk)
	begin
		q1_clk=~q1_clk;
	end
	
	always @(negedge pll_clk)
	begin
		q2_clk=~q2_clk;
	end

	assign mem_clk=q1_clk-q2_clk;

	always @(posedge mem_clk)
	begin
		cpu_clk=~cpu_clk;
	end
*/	
	always @(posedge cpu_clk)
	begin
		counting <= counting + 8'b00000001;
		if (counting==8'h21)
		begin
			counting <= 8'b0;
			reset=1'b0;
		end
/*		LEDcount <= LEDcount + 27'h00000001;
		if (LEDcount==27'h00000001)
		begin
			LEDswitch=~LEDswitch;
		end
*/
	end
//	assign LEDout=LEDswitch;

	// Memory clock must be 3-4 times the cpu clock:
	// Fetch byte 1
	// Fetch byte 2
	// Run CPU (cpu_clk positive edge)
	// Read/write something
	// We have to assume that read/write happends around negedge.
	// (Write can be delayed, but read needs to finish before next cpu_clk posedge)
	// If target address is delayed, one may need faster memory clock.

	MiniMem MA(.ClockA(mem_clk), .ClockEnA(1'b1), .ResetA(reset), .WrA(1'b0), 
	.AddressA({1'b0,cpu_addr,cpu_clk}), .DataInA(cpu_dataout), .QA(mem_dataout),
	.ClockB(~mem_clk), .ClockEnB(1'b1), .ResetB(reset), .WrB(cpu_we), 
	.AddressB({1'b1,cpu_addr2}), .DataInB(cpu_dataout), .QB(rwdatain)); //

/*	MiniMemB MB(.ClockA(mem_clk), .ClockEnA(1'b1), .ResetA(reset), .WrA(1'b0), 
	.AddressA({1'b0,cpu_addrB,cpu_clk}), .DataInA(cpu_dataoutB), .QA(mem_dataoutB),
	.ClockB(~mem_clk), .ClockEnB(1'b1), .ResetB(reset), .WrB(cpu_weB), 
	.AddressB({2'b10,cpu_addr2B}), .DataInB(cpu_dataoutB), .QB(rwdatainB)); //
*/
	always @(posedge cpu_clk)
	begin
		cpu_datain1 = mem_dataout1;
		cpu_datain2 = mem_dataout;
		cpu_datain1B = mem_dataout1B;
		cpu_datain2B = mem_dataoutB;
	end
	always @(negedge cpu_clk)
	begin
		mem_dataout1 = mem_dataout;
		mem_dataout1B = mem_dataoutB;
	end


	//assign cpu_datain1 = cpu_clk ? mem_dataout : cpu_datain1;
	//assign cpu_datain2 = cpu_clk ? cpu_datain2 : mem_dataout;

	c65n02 CA(.address(cpu_addr),.datain1(cpu_datain1),.datain2(cpu_datain2),.addressout(cpu_addr2),.dataout(cpu_dataout),
	.rwdatain(rwdatain),.we(cpu_we),.rst(reset),.clk(cpu_clk));

//	c65n02B CB(.address(cpu_addrB),.datain1(cpu_datain1B),.datain2(cpu_datain2B),.addressout(cpu_addr2B),.dataout(cpu_dataoutB),
//	.rwdatain(rwdatainB),.we(cpu_weB),.rst(reset),.clk(cpu_clk));

//	assign rwdataout = cpu_we ? cpu_dataout : 8'bzzzzzzzz;  //NB: Mamger accumulator;


endmodule
	